Attribute VB_Name = "Module1"
Option Explicit
 
  Public Const HKEY_CURRENT_USER = &H80000001
  Public Const KEY_QUERY_VALUE = &H1
  Public Const KEY_SET_VALUE = &H2
  Public Const KEY_CREATE_SUB_KEY = &H4
  Public Const KEY_ENUMERATE_SUB_KEYS = &H8
  Public Const KEY_NOTIFY = &H10
  Public Const KEY_CREATE_LINK = &H20
  Public Const STANDARD_RIGHTS_ALL = &H1F0000
  Public Const SYNCHRONIZE = &H100000
  Public Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or _
    KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or _
    KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) _
    And (Not SYNCHRONIZE))
   
  Public Const REG_SZ = 1
  Public Const REG_BINARY = 3
  Public Const REG_DWORD = 4
   
  Public Const REG_CREATED_NEW_KEY = &H1
  Public Const REG_OPENED_EXISTING_KEY = &H2
  Public Const REG_OPTION_NON_VOLATILE = 0
   
  Public Const ERROR_SUCCESS As Long = 0
  Public Const ERROR_MORE_DATA As Long = 234
   
  Public Type SECURITY_ATTRIBUTES
    nLength As Long
    lpSecurityDescriptor As Long
    bInheritHandle As Long
  End Type
   
  Public Declare Function RegCloseKey Lib "advapi32.dll" _
    (ByVal hKey As Long) As Long
   
  Public Declare Function RegCreateKeyEx Lib "advapi32.dll" _
    Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey _
    As String, ByVal Reserved As Long, ByVal lpClass As String, _
    ByVal dwOptions As Long, ByVal samDesired As Long, _
    lpSecurityAttributes As SECURITY_ATTRIBUTES, phkResult As Long, _
    lpdwDisposition As Long) As Long
  Public Declare Function RegDeleteKey Lib "advapi32.dll" Alias _
    "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) _
    As Long
  Public Declare Function RegDeleteValue Lib "advapi32.dll" Alias _
    "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As _
     String) As Long
  Public Declare Function RegQueryValueEx Lib "advapi32.dll" Alias _
    "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, _
    ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData _
    As Long) As Long
    ' Jeli parametr lpData bdzie typu String, to musi by przekazany
    ' ByVal
  Public Declare Function RegSetValueEx Lib "advapi32.dll" Alias _
    "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, _
    ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, _
    ByVal cbData As Long) As Long
   
  Public Sub Reg_Test_API()
    Dim hKey As Long, strKey As String
    Dim lRet As Long, lDisp As Long
    Dim sa As SECURITY_ATTRIBUTES, lValue As Long
    Dim lSize As Long, lType As Long
    Dim strValue As String, btValue(2) As Byte
    Dim strOut As String, i As Long
    Dim hTemp As Long
   
    '1. utworzenie klucza
    lRet = RegCreateKeyEx(HKEY_CURRENT_USER, "Test", 0&, vbNullString, _
      REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, sa, hKey, lDisp)
    If lRet <> ERROR_SUCCESS Then Exit Sub
    If lDisp = REG_CREATED_NEW_KEY Then
      Debug.Print "Klucz ""HKCU\Test"" nie istnia."
    Else
      Debug.Print "Otwarto istniejcy klucz ""HKCU\Test""."
    End If
   
    '2. utworzenie podklucza
    lRet = RegCreateKeyEx(hKey, "PodTest", 0&, vbNullString, _
      REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, sa, hTemp, lDisp)
    If lRet <> ERROR_SUCCESS Then Exit Sub
    If lDisp = REG_CREATED_NEW_KEY Then
      Debug.Print "Klucz ""HKCU\Test\PodTest"" nie istnia."
    Else
      Debug.Print "Otwarto istniejcy klucz ""HKCU\Test\PodTest""."
    End If
   
    '3. dodanie domylnej wartoci do podklucza
    strValue = "xyz"
    lRet = RegSetValueEx(hTemp, "", 0&, REG_SZ, ByVal strValue, Len(strValue))
    If lRet <> ERROR_SUCCESS Then Exit Sub
   
    '4. utworzenie wartoci numerycznej
    lValue = 24
    lRet = RegSetValueEx(hKey, "Test Value 1", 0&, REG_DWORD, lValue, Len(lValue))
    If lRet <> ERROR_SUCCESS Then Exit Sub
   
    '5. utworzenie wartoci napisowej
    strValue = "sample value"
    lRet = RegSetValueEx(hKey, "Test Value 2", 0&, REG_SZ, ByVal strValue, _
      Len(strValue))
    If lRet <> ERROR_SUCCESS Then Exit Sub
   
    '6. utworzenie wartoci binarnej
    btValue(0) = 40
    btValue(1) = 15
    btValue(2) = 255
    lRet = RegSetValueEx(hKey, "Test Value 3", 0&, REG_BINARY, btValue(0), _
      UBound(btValue) - LBound(btValue) + 1)
    If lRet <> ERROR_SUCCESS Then Exit Sub
   
    '7. oczyt wartoci numerycznej
    lValue = 0
    lSize = 4
    lRet = RegQueryValueEx(hKey, "Test Value 1", 0&, lType, lValue, lSize)
    If lRet <> ERROR_SUCCESS Then Exit Sub
    Debug.Print "Wartosc ""HKCU\Test\Test Value 1"" : " & lValue
   
    '8. odczyt wartoci napisowej
    strValue = ""
    lSize = Len(strValue)
    lRet = RegQueryValueEx(hKey, "Test Value 2", 0&, lType, lValue, lSize)
    If lRet = ERROR_MORE_DATA Then
      strValue = Space$(lSize)
      lRet = RegQueryValueEx(hKey, "Test Value 2", 0&, lType, ByVal strValue, _
        lSize)
      If lRet <> ERROR_SUCCESS Then Exit Sub
    ElseIf lRet <> ERROR_SUCCESS Then
      Exit Sub
    End If
    Debug.Print "Warto ""HKCU\Test\Test Value 2"" : " & Left$(strValue, _
      Len(strValue) - 1)
   
    '9. odczyt wartoci binarnej
    btValue(0) = 0:   btValue(1) = 0:   btValue(2) = 0
    lSize = UBound(btValue) - LBound(btValue) + 1
    lRet = RegQueryValueEx(hKey, "Test Value 3", 0&, lType, btValue(0), lSize)
    If lRet <> ERROR_SUCCESS Then
      Exit Sub
    End If
    For i = LBound(btValue) To UBound(btValue)
      strOut = strOut & Format(Hex$(btValue(i)), "@@") & " "
    Next i
    Debug.Print "Warto ""HKCU\Test\Test Value 3"" : " & strOut
   
    '10. odczyt domylnej wartoci (napisowej)
    strValue = ""
    lSize = Len(strValue)
    lRet = RegQueryValueEx(hTemp, "", 0&, lType, lValue, lSize)
    If lRet = ERROR_SUCCESS Then
      Debug.Print """HKCU\Test\PodTest"" nie ma ustawionej wartoci domylnej."
    ElseIf lRet = ERROR_MORE_DATA Then
      strValue = Space$(lSize)
      lRet = RegQueryValueEx(hTemp, "", 0&, lType, ByVal strValue, lSize)
      If lRet <> ERROR_SUCCESS Then Exit Sub
    Else
      Exit Sub
    End If
    Debug.Print "Domylna warto ""HKCU\Test\PodTest"" : " & strValue
   
    '11. zamknicie podklucza
    lRet = RegCloseKey(hTemp)
   
    '12. usunicie wartoci
    '    nie jest to konieczne do usunicia klucza
    lRet = RegDeleteValue(hKey, "Test Value 1")
    If lRet <> ERROR_SUCCESS Then Exit Sub
    lRet = RegDeleteValue(hKey, "Test Value 2")
    If lRet <> ERROR_SUCCESS Then Exit Sub
    lRet = RegDeleteValue(hKey, "Test Value 3")
    If lRet <> ERROR_SUCCESS Then Exit Sub
   
    '13. usunicie klucza
    '    pod Win9x RegDeleteKey usuwa klucz wraz z wartociami i podkluczami.
    '    pod WinNT RegDeleteKey usuwa klucz z wartociami, ale nie jeli
    '    klucz ma podklucze; trzeba je wszystkie usun "rcznie"
    lRet = RegDeleteKey(hKey, "")
    If lRet <> ERROR_SUCCESS Then
      Debug.Print "Klucz ""HKCU\Test"" nie mg zosta usunity."
      lRet = RegDeleteKey(HKEY_CURRENT_USER, "Test\PodTest")
      If lRet <> ERROR_SUCCESS Then
        Debug.Print "Klucz ""HKCU\Test\PodTest"" nie mg zosta usunity."
      Else
        Debug.Print "Klucz ""HKCU\Test\PodTest"" usunity."
        lRet = RegDeleteKey(hKey, "")
        If lRet = ERROR_SUCCESS Then
          Debug.Print "Klucz ""HKCU\Test"" usunity."
        Else
          Debug.Print "Klucz ""HKCU\Test"" nie mg zosta usunity."
        End If
      End If
    Else
      Debug.Print "Klucz ""HKCU\Test"" usunity."
    End If
  End Sub



